procedure blurr(x1,y1,x2,y2:integer);
var
 x,y,i,j,k,l,n,c,oc:integer;
begin
 for i:=x1 to x2 do
  for k:=y1 to y2 do
   begin
    c:=getpixel(i,k); n:=c;
    if c=0 then n:=7*32;
    if n<>c then putpixel(i,k,n);
   end;
 for i:=x1 to x2 do
  for k:=y1 to y2 do
   begin
    n:=getpixel(i,k);
    if (i>0) and (k>0) and (n>=32) then
     begin
      j:=0; l:=0; oc:=getpixel(i,k) div 32;
      for x:=i-1 to i+1 do
       for y:=k-1 to k+1 do
        begin
         c:=getpixel(x,y);
         if c>=32 then begin j:=j+(c mod 32); inc(l); end;
        end;
      j:=round(j/l)+(oc*32);
      putpixel(i,k,j);
     end;
   end;
 for i:=x1 to x2 do
  for k:=y1 to y2 do
   begin
    c:=getpixel(i,k); n:=c;
    if c mod 32=0 then n:=0;
    if n<>c then putpixel(i,k,n);
   end;
end;

procedure tm(x,y,col:integer);
begin
 setcolor(col);
 {circle(x,y,8);}
 line(x-5,y-2,x-1,y-2);
 line(x-3,y-2,x-3,y+2);
 line(x+1,y-2,x+1,y+2);
 line(x+1,y-2,x+3,y);
 line(x+5,y-2,x+5,y+2);
 line(x+5,y-2,x+3,y);
end;

procedure make_logo(fn:string);
var
 i,k,l,x,y,xx,yy,sz:integer;
 b:byte;
 f:text;
 h:word;
 p1:pointer;
begin
 assign(f,fn);
 reset(f);
 readln(f,b); x:=b-1;
 readln(f,b); y:=b-1;
 sz:=logo_size; xx:=159-(((x+1)*sz) div 2); yy:=99-(((y+1)*sz) div 2);
 for i:=0 to x do
  for k:=0 to y do
   begin
    readln(f,b);
    setfillstyle(1,b);
    bar(xx+i*sz,yy+k*sz,xx+i*sz+sz-1,yy+k*sz+sz-1);
   end;
 close(f);
 blurr(xx-10,yy-10,xx+sz*(x+1)+10,yy+sz*(y+1)+10);
 tm(xx+sz*x-10,yy+10,3*32+7);
 open_fileout(h,'Logo.Dat');
 x:=x+2; y:=y+2; xx:=xx-sz; yy:=yy-sz;
 i:=(x+1)*sz+1;
 k:=(y+1)*sz+1;
 l:=2; write_file(h,@i,l);
 l:=2; write_file(h,@k,l);
 l:=imagesize(0,0,(x+1)*sz,(y+1)*sz);
 getmem(p1,l);
 getimage(xx,yy,xx+(x+1)*sz,yy+(y+1)*sz,p1^);
 write_file(h,p1,l);
 close_file(h);
 freemem(p1,imagesize(0,0,(x+1)*sz,(y+1)*sz));
end;


procedure create_logo;
var
 i,j,k:integer;
begin
 settextstyle(defaultfont,horizdir,1);
 settextjustify(centertext,toptext);
 setcolor(255);
 outtextxy(160,190,'Loading...');
 make_logo('Necrolog.img');
 setfillstyle(1,0);
 bar(0,190,320,200);
 settextjustify(lefttext,toptext);
end;


