unit svgabgi;

{ This unit took my "blazebgi" unit and made it more generic in use. -Ed. }

interface

uses blazebgi, graph;

var
 vga_graph_mode:integer;

Procedure GraphitV;
procedure Abort(Msg : string);

implementation

procedure Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

(* 'Detection' routine *)
{$F+}                                   (* Force to far calls *)
function DetectVGA : Integer;
var Vid : Integer;

begin
  {Writeln('Which video mode would you like to use?');
  Writeln('  0) 320x200x256');
  Writeln('  1) 640x400x256');
  Writeln('  2) 640x480x256');
  Writeln('  3) 800x600x256');
  Writeln('  4) 1024x768x256');
  Write('> ');
  Readln(Vid);}

  vid:=vga_graph_mode;
  DetectVGA := Vid;
end;
{$F-}

Procedure GraphitV;
var
  graphmode,graphdriver,i:integer;
  autodetect:pointer;
  s:string[80];
begin
  {s:=path(paramstr(0));
  s[0]:=chr(ord(s[0])-1);}
  s:='';
  AutoDetect := @DetectVGA;
  GraphDriver := InstallUserDriver('SVGA256',AutoDetect);
  GraphDriver := Detect;
  GraphMode   := DetectVGA;
  if RegisterBGIdriver(@svgaDriverProc) < 0 then
    Abort('SVGA256 Driver');
  InitGraph(GraphDriver,GraphMode,s);
  i:=graphresult;
  if (i<>0) then
   begin
    writeln('Graphics Error #',i,': ',grapherrormsg(i));
    writeln('You must have a VGA to run this program');  halt(1);
   end;
  setactivepage(0);
  setvisualpage(0);
  setcolor(15);				(* Remember to do this *)
end;

begin
 vga_graph_mode:=0;
end.
