
{ Copyright (c) 1985, 1990 by Borland International, Inc. }

unit egavga;
{ Sample unit to accompany BGILINK.PAS. This unit links the BGI graphics
  driver into a single TPU file. This makes it easy to link the driver files
  directly into an .EXE file. See BGILINK.PAS for more information.
}
interface

uses graph;


procedure egavgaProc;
procedure graph_Abort(Msg : string);
Procedure Graph_VGA;

implementation


procedure egavgaProc; external;
{$L egavga.OBJ }

procedure graph_Abort(Msg : string);
begin
  Writeln(Msg, ': ', GraphErrorMsg(GraphResult));
  Halt(1);
end;

Procedure Graph_VGA;
var
 driver, mode:integer;
 i:integer;
begin
   if RegisterBGIdriver(@EGAVGAProc) < 0 then
     graph_Abort('EGA/VGA');

      driver:=VGA; mode:=VGAHI;
      initgraph(driver,mode,'');
      i:=graphresult;
      if (i<>0) then
       begin
        writeln('Graphics Error: ',GraphErrorMsg(i));
	writeln('You must have a VGA to use 640x480x16 mode');
	halt;
       end;
end;

end.
