procedure show_logo(px,py:integer; fn:string);
var
 i,k,l,x,y:integer;
 h:word;
 p1:pointer;
begin
 if not exist(fn) then
  begin
   settextjustify(centertext,toptext);
   setcolor(15);
   outtextxy(px,py,'Logo File Not Found!');
   settextjustify(lefttext,toptext);
   exit;
  end;
 open_filein(h,fn);
 l:=2; read_file(h,@x,l);
 l:=2; read_file(h,@y,l);
 dec(x); dec(y);
 l:=imagesize(0,0,x,y);
 getmem(p1,l);
 read_file(h,p1,l);
 {putimage(px-((x+1) div 2),py-((y+1) div 2),p1^,copyput);}
 img_matte(px-((x+1) div 2),py-((y+1) div 2),p1);
 close_file(h);
 freemem(p1,imagesize(0,0,x,y));
end;

procedure necrologo(px,py:integer; palname:string; title:boolean);
var
 i,j,k,l:integer;
 ar:array[0..107] of byte;
 w:word;
begin
 if title then
  begin
   for i:=0 to 107 do
    ar[i]:=random(20);
   k:=32;
   for i:=160 to 199 do
    begin
     dec(k); if k<16 then k:=k+16;
     setcolor(k);
     for j:=1 to 107 do
      line((j-1)*3,i+ar[j-1],j*3,i+ar[j]);
    end;
  end;
 show_logo(px,py,'Logo.dat');
 if title then
  begin
   load_palette(palname);
   flushkey;
   k:=0;
   repeat
    inc(k); if k>15 then k:=0; l:=16;
    for j:=k+16 downto k+1 do
     begin
      dec(l);
      i:=j; if i<16 then i:=i+16;
      color[i].red:=40;
      color[i].green:=l*2+10;
      color[i].blue:=0;
     end;
    setpal(@color,15,20);
    repeat
    until w<>mem[0:$46C];
    w:=mem[0:$46C];
   until keypressed;
   flushkey;
  end;
end;

